;; absoluteblue/theme.jl

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>
;; copyright (c) 2001 Julio Biason <slow_rs@ig.com.br>

(let*
    ((title-width (lambda (w)
		    (let
			((w-width (car (window-dimensions w))))
		      (- (min (max (/ w-width 2) 100) w-width) 16))))
     
     ;; 100x16
     (bar-images (mapcar (lambda (i)
			   (set-image-border i 4 4 4 4))
			 (list (make-image "bar_normal.png")
			       (make-image "bar_normal_active.png")
			       (make-image "bar_hilited_active.png")
			       (make-image "bar_clicked_active.png"))))

     (frame `(
	      ((background . ,bar-images)
	       (foreground . "white")
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 0)
	       (width . ,title-width)
	       (top-edge . -16)
		   (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-iso8859-1")
	       (class . title))
	      ((background . ,bar-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) )))
	       (right-edge . 0)
	       (top-edge . -4)
	       (height . 4)
	       (class . top-border))
	      ((background . ,bar-images)
	       (right-edge . -4)
	       (width . 4)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))
	      ((background . ,bar-images)
	       (left-edge . -4)
	       (width . 4)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))
	      ((background . ,bar-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -4)
	       (height . 4)
	       (class . bottom-border))
	      ((background . ,bar-images)
	       (left-edge . -4)
	       (width . 4)
	       (top-edge . -4)
	       (height . 4)
	       (class . top-left-corner))
	      ((background . ,bar-images)
	       (right-edge . -4)
	       (width . 4)
	       (top-edge . -4)
	       (height . 4)
	       (class . top-right-corner))
	      ((background . ,bar-images)
	       (left-edge . -4)
	       (width . 4)
	       (bottom-edge . -4)
	       (height . 4)
	       (class . bottom-left-corner))
	      ((background . ,bar-images)
	       (right-edge . -4)
	       (width . 4)
	       (bottom-edge . -4)
	       (height . 4)
	       (class . bottom-right-corner))))

     (shaped-frame `(
		     ((background . ,bar-images)
		      (foreground . "white")
		      (text . ,window-name)
		      (x-justify . center)
		      (y-justify . center)
		      (left-edge . 0)
		      (width . ,title-width)
		      (top-edge . -16)
		      (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-iso8859-1")
		      (class . title))
             ))

     (transient-frame `(((background . ,bar-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (top-edge . -4)
			 (height . 4)
			 (class . title))
			((background . ,bar-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (bottom-edge . -4)
			 (height . 4)
			 (class . bottom-border))
			((background . ,bar-images)
			 (left-edge . -4)
			 (width . 4)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . left-border))
			((background . ,bar-images)
			 (right-edge . -4)
			 (width . 4)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . right-border))
			((background . ,bar-images)
			 (right-edge . -4)
			 (width . 4)
			 (top-edge . -4)
			 (height . 4)
			 (class . top-right-corner))
			((background . ,bar-images)
			 (left-edge . -4)
			 (width . 4)
			 (top-edge . -4)
			 (height . 4)
			 (class . top-left-corner))
			((background . ,bar-images)
			 (left-edge . -4)
			 (width . 4)
			 (bottom-edge . -4)
			 (height . 4)
			 (class . bottom-left-corner))
			((background . ,bar-images)
			 (right-edge . -4)
			 (width . 4)
			 (bottom-edge . -4)
			 (height . 4)
			 (class . bottom-right-corner))))

     (shaped-transient-frame `(((background . ,bar-images)
				(left-edge . 0)
				(right-edge . 0)
				(top-edge . -4)
				(height . 4)
				(class . title)))))

  (add-frame-style 'absoluteblue
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame)))))
